/* 
 * $TSUKUBA_Release: Omni Compiler Version 0.9.0 $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010-2014 University of Tsukuba, 
 *  	      2012-2014  University of Tsukuba and Riken AICS
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the files named
 *  COPYRIGHT and LICENSE under the top  directory of the Omni Compiler
 *  Software release kit.
 *  
 *  * The specification of XcalableMP has been designed by the XcalableMP
 *    Specification Working Group (http://www.xcalablemp.org/).
 *  
 *  * The development of this software was partially supported by "Seamless and
 *    Highly-productive Parallel Programming Environment for
 *    High-performance computing" project funded by Ministry of Education,
 *    Culture, Sports, Science and Technology, Japan.
 *  $
 */
package xcodeml.c.binding;

import xcodeml.c.binding.gen.IXbcExpressionsChoice;

/**
 * Concretes class implement the interface are follows: 
 * XbcMemberRef, XbcMemberAddr, XbcMmberArrayRef, XbcMemberArrayAddr.
 */
public interface IXbcMember extends IXbcTypedExpr
{
    /**
     * Gets content of a member attribute.
     * 
     * @return content of a member attribute.
     */
    public String getMember();

    public void setMember(String member);

    /**
     * Gets the single term of this expression interface.
     *
     * @return the single term of this expression
     */
    public IXbcExpressionsChoice getExpressions();

    public void setExpressions(IXbcExpressionsChoice choice);
}
